// MDIEditorView.h : interface of the CMDIEditorView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MDIEDITORVIEW_H__0C58F52E_F8A0_4B43_9972_F7AF9A0BE0CA__INCLUDED_)
#define AFX_MDIEDITORVIEW_H__0C58F52E_F8A0_4B43_9972_F7AF9A0BE0CA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCustomEditCtrl;

class CMDIEditorView : public CBCGPEditView
{
protected: // create from serialization only
	CMDIEditorView();
	DECLARE_DYNCREATE(CMDIEditorView)

// Attributes
public:
	CMDIEditorDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMDIEditorView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMDIEditorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	CImageList			m_imgList;
	CFont				m_Font;
	CCustomEditCtrl*	m_pEdit;

	virtual CBCGPEditCtrl* CreateEdit ();

// Generated message map functions
protected:
	//{{AFX_MSG(CMDIEditorView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnEditTogglebookmark();
	afx_msg void OnEditNextbookmark();
	afx_msg void OnEditPreviousbookmark();
	afx_msg void OnEditListmembers();
	afx_msg void OnEditFindnext();
	afx_msg void OnEditFindprev();
	afx_msg void OnEditTogglebreakpoint();
	afx_msg void OnUpdateEditTogglebreakpoint(CCmdUI* pCmdUI);
	afx_msg void OnEditRemoveAllBreakpoints();
	afx_msg void OnUpdateEditRemoveAllBreakpoints(CCmdUI* pCmdUI);
	afx_msg void OnUpdateEditListmembers(CCmdUI* pCmdUI);
	afx_msg void OnViewFont();
	//}}AFX_MSG
	afx_msg void OnUpdateCursorPos(CCmdUI *pCmdUI);
	DECLARE_MESSAGE_MAP()

private:
	void ResetDefaultFont();
	BOOL RestoreDefaultData();
};

#ifndef _DEBUG  // debug version in MDIEditorView.cpp
inline CMDIEditorDoc* CMDIEditorView::GetDocument()
   { return (CMDIEditorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MDIEDITORVIEW_H__0C58F52E_F8A0_4B43_9972_F7AF9A0BE0CA__INCLUDED_)
